package builtins

import "git.sr.ht/~cco/go-scopes/forge"

type FE = forge.FE
type XT = forge.XT

type builtins struct {
	Add, Body, Dup, Get, Lit, Mult, Put, Reg XT
}

func Get(f FE) *builtins {
	if v, ok := f.Voc().Lookup("builtins"); ok {
		return v.(*builtins)
	}
	b := setup(f)
	f.Voc().Register("builtins", b)
	return b
}

func setup(f FE) *builtins {
	voc := f.Voc()
	r := func(name string, fct forge.Callable) XT {
		return forge.Register(voc, forge.GoFunc(name, fct))
	}
	b := builtins{
		Add: r("+", func(f FE, _ XT) { f.Push(f.Pop().(int) + f.Pop().(int)) }),
		Body: r("body", func(f FE, _ XT) {
			f.Push(f.Pop().(forge.XT).Code().New().Next())
		}),
		Dup:  r("dup", func(f FE, _ XT) { f.Push(f.Peek(0)) }),
		Get:  r("@", func(f FE, _ XT) { f.Push(f.Pop().(forge.FPtr).Value()) }),
		Lit:  r("lit", func(f FE, _ XT) { f.Push(f.Literal()) }),
		Mult: r("*", func(f FE, _ XT) { f.Push(f.Pop().(int) * f.Pop().(int)) }),
		Put:  r("!", func(f FE, _ XT) { f.Pop().(forge.FPtr).Set(f.Pop()) }),
		Reg: r("reg", func(f FE, _ XT) {
			f.Push(forge.Register(voc,
				forge.FCode(f.Pop().(string), f.Pop().(forge.FPtr))))
		}),
	}
	return &b
}
